﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


namespace Wpf_AsyncWcfClientApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        PersonWcfService.PersonWcfServiceClient proxy = new PersonWcfService.PersonWcfServiceClient();

        System.Collections.ObjectModel.ObservableCollection<PersonWcfService.PersonDTO> AllePersoner =
            new System.Collections.ObjectModel.ObservableCollection<PersonWcfService.PersonDTO>();

        public MainWindow()
        {
            InitializeComponent();
            proxy.GetAllePersonerMedPostnrCompleted += onGetAllePersonerMedPostnrCompleted;
            //DataContext = this;   // databinding til LbxPersoner.ItemsSource er i this på AllePersoner
            this.LbxPersoner.ItemsSource = AllePersoner;
        }

        private int postnr;
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            postnr = 5000;
            proxy.GetAllePersonerMedPostnrAsync(postnr, postnr+99, false);
        }
        private void onGetAllePersonerMedPostnrCompleted
            (object sender,
            PersonWcfService.GetAllePersonerMedPostnrCompletedEventArgs e)
        {
            // dette sker i GUI tråd
            var personer = e.Result;
            foreach (var person in personer)
            {
                //Thread.Sleep(500);
                AllePersoner.Insert(0,person);
            }
            if (postnr < 9999)
            {
                //Thread.Sleep(4000);
                postnr += 100;
                proxy.GetAllePersonerMedPostnrAsync(postnr, postnr + 99, false);
            }
            else
                MessageBox.Show("Personer hentet");


        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            if (AllePersoner.Count>0)
                AllePersoner[0].Efternavn += " x";
        }

    }
}
